// Akos.h
// By Nolan Check

#pragma once

#include "AkosView.h"
#include "Sprite.h"

#include <pshpack1.h>
struct AKHDBLOCK
{
	WORD unk1;
	BYTE bFlags;
	BYTE unk2;
	WORD wNumAnims;
	WORD wNumFrames;
	WORD wCodec;
};
#include <poppack.h>

#include <pshpack1.h>
struct AKOFENTRY
{
	DWORD dwAKCD;
	WORD  wAKCI;
};
#include <poppack.h>

#include <pshpack1.h>
struct AKCIENTRY
{
	WORD wWidth;
	WORD wHeight;
	INT16 relX;
	INT16 relY;
	INT16 movX;
	INT16 movY;
};
#include <poppack.h>

class Akos
{
public:
	Akos(BYTE* pAkosData)
	{
		m_pAkosData     = pAkosData;
		m_wCurrentFrame = 0;
		m_pRGBS         = NULL;
	};

	bool Initialize();
	bool LoadFrame(WORD wFrame);
	bool DrawFrame(Sprite& sprite, int x, int y);

	WORD GetCurrentFrame()
	{
		return m_wCurrentFrame;
	};
	WORD GetMaxFrames()
	{
		return m_pAKHD->wNumFrames;
	};
private:
	void Codec1(BYTE* pDst);
	void Codec5(BYTE* pDst);
	void Codec16(BYTE* pDst);

	BYTE* m_pAkosData;
	DWORD m_dwNumColors;

	AKHDBLOCK* m_pAKHD;
	BYTE*      m_pAKPL;
	BYTE*      m_pRGBS;
	BYTE*      m_pAKSQ;
	BYTE*      m_pAKCH;
	AKOFENTRY* m_pAKOF;
	BYTE*      m_pAKCI;
	BYTE*      m_pAKCD;

	WORD       m_wCurrentFrame;
	AKCIENTRY* m_pCurrentAKCI;
	BYTE*      m_pCurrentAKCD;
};