// AkosBrowser.h
// By Nolan Check

#pragma once

#include "AkosView.h"
#include "Display.h"
#include "Akos.h"
#include "Scumm.h"

class AkosBrowser
{
public:
	AkosBrowser()
	{
		m_fZoom          = false;
		m_fCostumeLoaded = false;
		m_fFrameLoaded   = false;

		m_lpGamePath            = NULL;
		m_lpGameName            = NULL;
		m_pScummResourceManager = NULL;
		m_pAkos                 = NULL;
		m_pAkosData             = NULL;
	};

	bool Initialize(LPTSTR lpGamePath, LPTSTR lpGameName);
	void Destroy();
	void LoadCostume(DWORD dwCostume);
	void AdvanceCostume();
	void BackCostume();
	void LoadFrame(WORD wFrame);
	void AdvanceFrame();
	void BackFrame();
	void DrawFrame(Display& display);

	void SetZoom(bool fZoom)
	{
		m_fZoom = fZoom;
	};
private:
	bool  m_fZoom;
	bool  m_fCostumeLoaded;
	bool  m_fFrameLoaded;
	DWORD m_dwCurrentCostume;

	LPTSTR                m_lpGamePath;
	LPTSTR                m_lpGameName;
	ScummResourceManager* m_pScummResourceManager;
	Akos*                 m_pAkos;
	BYTE*                 m_pAkosData;
};