// BitStream.h
// By Nolan Check

#pragma once

class BitStream
{
public:
	BitStream(BYTE* pBits)
	{
		m_pBits   = pBits;
		m_numBits = 8;
		m_bBuffer   = *m_pBits;
	};

	BYTE ReadBits(int count)
	{
		BYTE bResult = 0;
		for (int i = 0; i < count; i++)
		{
			if (m_bBuffer & 1)
			{
				bResult |= (1 << i);
			}
			m_bBuffer >>= 1;
			if (!--m_numBits)
			{
				m_numBits = 8;
				m_bBuffer = *++m_pBits;
			}
		}
		return bResult;
	};
private:
	BYTE* m_pBits;
	int   m_numBits;
	BYTE  m_bBuffer;
};