// Display.h
// By Nolan Check

#pragma once

#include "AkosView.h"
#include "Sprite.h"

class Display
{
public:
	Display()
	{
		m_fReady = false;
	};

	bool Initialize(HWND hWindow);
	void Destroy();
	void SetPalette(BYTE* pPalette, UINT numColors);
	void Clear();
	void DrawSprite(Sprite& sprite);

	HDC GetHDC()
	{
		return m_hdcDisplay;
	};
	BYTE* GetBits()
	{
		return m_pBits;
	};
private:
	bool    m_fReady;
	HWND    m_hWindow;

	HBITMAP m_hbmDisplay;
	HDC     m_hdcDisplay;
	HBITMAP m_hbmOld;
	BYTE*   m_pBits;
};