// File.cpp
// By Nolan Check

#include "File.h"

bool File::Open(LPCTSTR lpFileName)
{
	m_hFile = CreateFile(lpFileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (m_hFile == INVALID_HANDLE_VALUE)
	{
		ErrorMessage("Failed to open file.");
		return false;
	}
	m_dwSize = GetFileSize(m_hFile, NULL);
	return true;
}

void File::Close()
{
	if (m_hFile != INVALID_HANDLE_VALUE)
	{
		CloseHandle(m_hFile);
		m_hFile = INVALID_HANDLE_VALUE;
	}
}

bool File::Read(LPVOID lpBuffer, DWORD dwNumBytes)
{
	DWORD dwBytesRead;
	if (!ReadFile(m_hFile, lpBuffer, dwNumBytes, &dwBytesRead, NULL))
	{
		ErrorMessage("Failed to read from a file.");
		return false;
	}
	if (dwBytesRead != dwNumBytes)
	{
		ErrorMessage("Failed to read from a file.");
		return false;
	}
	return true;
}

bool File::SeekSet(LONG lDistance)
{
	if (SetFilePointer(m_hFile, lDistance, NULL, FILE_BEGIN) == INVALID_SET_FILE_POINTER)
	{
		ErrorMessage("Failed to seek a file.");
		return false;
	}
	return true;
}

bool File::SeekCurrent(LONG lDistance)
{
	if (SetFilePointer(m_hFile, lDistance, NULL, FILE_CURRENT) == INVALID_SET_FILE_POINTER)
	{
		ErrorMessage("Failed to seek a file.");
		return false;
	}
	return true;
}