// Sprite.cpp
// By Nolan Check

#include "Sprite.h"

bool Sprite::Initialize(int x, int y, WORD wWidth, WORD wHeight, UINT numColors)
{
	m_x         = x;
	m_y         = y;
	m_wWidth    = wWidth;
	m_wHeight   = wHeight;
	m_numColors = numColors;

	m_pBits = (BYTE*)malloc(m_wWidth * m_wHeight);
	if (!m_pBits)
	{
		ErrorMessage("Out of memory.");
		return false;
	}

	m_pPalette = (BYTE*)malloc(m_numColors * 3);
	if (!m_pPalette)
	{
		ErrorMessage("Out of memory.");
		return false;
	}

	return true;
}

void Sprite::Destroy()
{
	if (m_pPalette)
	{
		free(m_pPalette);
		m_pPalette = NULL;
	}
	if (m_pBits)
	{
		free(m_pBits);
		m_pBits = NULL;
	}
}